namespace PkmnLib.Dynamic;

/// <summary>
/// A static helper class that contains functions that are used in multiple places.
/// </summary>
public static class StaticHelpers
{
    /// <summary>
    /// A function to get the current date and time. This can be replaced in cases where the date and time
    /// may not be the same as the system time.
    /// </summary>
    public static Func<DateTimeOffset> DateTimeProvider { get; set; } = () => DateTimeOffset.Now;
    
    /// <summary>
    /// Get the current date and time.
    /// </summary>
    public static DateTimeOffset GetCurrentDateTime() => DateTimeProvider();
}