using PkmnLib.Static;

namespace PkmnLib.Plugin.Gen7.Scripts.Moves;

[Script(ScriptCategory.Move, "belly_drum")]
public class BellyDrum : Script
{
    /// <inheritdoc />
    public override void OnSecondaryEffect(IExecutingMove move, IPokemon target, byte hit)
    {
        var maxHealthHalved = target.BoostedStats.Hp / 2;
        if (target.CurrentHealth <= maxHealthHalved)
        {
            move.GetHitData(target, hit).Fail();
            return;
        }
        
        target.Damage(maxHealthHalved, DamageSource.Misc);
        // Raising the user's Attack by 12 stages should always set it to +6.
        target.ChangeStatBoost(Statistic.Attack, 12, true);
    }
}