using PkmnLib.Static;

namespace PkmnLib.Plugin.Gen7.Scripts.Moves;

[Script(ScriptCategory.Move, "bug_bite")]
public class BugBite : Script
{
    /// <inheritdoc />
    public override void OnSecondaryEffect(IExecutingMove move, IPokemon target, byte hit)
    {
        var user = move.User;
        var battleData = user.BattleData;
        if (battleData == null)
            return;
        
        var targetHeldItem = target.HeldItem;
        
        if (targetHeldItem is not { Category: ItemCategory.Berry })
        {
            move.GetHitData(target, hit).Fail();
            return;
        }
        _ = target.SetHeldItem(null);
        targetHeldItem.RunItemScript(battleData.Battle.Library.ScriptResolver, user);
    }
}